/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exercise;

import exercise.spy.ComplicatedClass;
import exercise.spy.Logger;
import org.junit.Test;
import org.mockito.InOrder;
import static org.mockito.Matchers.anyString;
import static org.mockito.Matchers.eq;
import static org.mockito.Mockito.inOrder;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verifyZeroInteractions;

public class ComplicatedClassTest {

    @Test
    public void testGreater10() {
        Logger log = mock(Logger.class);

        ComplicatedClass sut = new ComplicatedClass(log);
        sut.doSomethingUseful(11);

        InOrder order = inOrder(log);
        order.verify(log, times(1)).setLevel("WARN");
        order.verify(log, times(1)).log(eq(ComplicatedClass.LOG_TAG), anyString());
    }

    @Test
    public void test10OrLower() {
        Logger log = mock(Logger.class);
        ComplicatedClass sut = new ComplicatedClass(log);
        sut.doSomethingUseful(10);

        verifyZeroInteractions(log);
    }

}
