/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package romancalculator.implementation;

import java.util.Iterator;
import romancalculator.framework.TokenStream;

public class IteratorTokenStream implements TokenStream {

	private Iterator<String> iterator;

	public IteratorTokenStream(Iterable<String> iteratorTarget) {
		this.iterator = iteratorTarget.iterator();
	}

	@Override
	public boolean hasNext() {
		return iterator.hasNext();
	}

	@Override
	public String next() {
		return iterator.next();
	}

}
